#pragma semicolon 1
#include <sourcemod>
#include <sdktools>
#include <sdkhooks>

#undef REQUIRE_PLUGIN 
#include <autoupdate>

#define PLUGIN_VERSION "1.1.0"

#define DEBUG 0

#define T_TEAM 2
#define CT_TEAM 3
#define TSPRITE "sprites/player_red_small.vmt"
#define CTSPRITE "sprites/player_blue_small.vmt"

#define BUGEDMODEL1 "models/player/ct_gsg9.mdl"
#define BUGEDMODEL2 "models/player/ct_sas.mdl"

public Plugin:myinfo = {
	name = "Admin ESP",
	author = "KawMAN",
	description = "",
	version = PLUGIN_VERSION,
	url = "http://www.wsciekle.pl/"
};

//For Dot ESP funtions
new clientsprite[MAXPLAYERS+1] = {-1, ...}; //Store clients positions sprites
new bool:espon[MAXPLAYERS+1] = {false, ...}; //Store setting
new bool:transmit[MAXPLAYERS+1] = {false, ...}; //quick check if should transmit

//For sv_cheats replication
new bool:cheaton[MAXPLAYERS+1] = { false, ... };

//Who observing who
new g_offObserverTarget;
new observing[MAXPLAYERS+1] = {0, ...};
new Handle:ObserverRefresh[MAXPLAYERS+1] = {INVALID_HANDLE, ...};

new Handle:hAutoUpdate = INVALID_HANDLE ;
new Handle:cSvCheats = INVALID_HANDLE;
new bool:SvCheats = false;
new Handle:cConfigs = INVALID_HANDLE;
new bool:sbeon = false; //ShouldBeOn() buffer
new bool:configs_on = false, bool:configs_on_executed = false;

public OnPluginStart()
{
	CreateConVar("sm_adminesp_v", PLUGIN_VERSION, "Admin ESP Version", FCVAR_PLUGIN|FCVAR_SPONLY|FCVAR_REPLICATED|FCVAR_NOTIFY);
	hAutoUpdate = CreateConVar("sm_adminesp_autoupdate", "1", "Autoupdate plugin (Require Plugin Autoupdater & Sockets)", FCVAR_PLUGIN,true,0.0,true,1.0); 
	HookConVarChange(hAutoUpdate, MyCVARChange);
	cConfigs = CreateConVar("sm_admincheat_config", "1", "If 1 configs will be executed when someone is using sv_cheats replication", FCVAR_PLUGIN,true,0.0,true,1.0);
	HookConVarChange(cConfigs, MyCVARChange);
	cSvCheats = FindConVar("sv_cheats");
	HookConVarChange(cSvCheats, MyCVARChange);
	
	UpdateState();
	
	//Load Languages
	LoadTranslations("common.phrases");
	
	//Hook Events
	HookEvent("player_spawn", Event_PlayerSpawn);
	HookEvent("player_death", Event_PlayerDeath);
	HookEvent("round_start", Event_RoundStart);
	
	//Register Commands
	RegAdminCmd("sm_adminesp", CmdAdminESP, ADMFLAG_GENERIC, "Admin ESP Set Command");
	RegAdminCmd("sm_admincheat", CmdAdminCheat, ADMFLAG_GENERIC, "Admin sv_cheat set Command");
	RegAdminCmd("sm_adminesp_table", CmdAdminESPTable, ADMFLAG_GENERIC, "Print Transmition Table"); 
	

	
	g_offObserverTarget = FindSendPropOffs("CBasePlayer", "m_hObserverTarget");	
	if(g_offObserverTarget == -1) 
	{
		SetFailState("Cant find m_hObserverTarget.");
	}
	
	#if DEBUG>0
	PrintToServer("[AdminESP:DEBUG] Plugin Loaded");
	#endif
}
public OnPluginEnd()
{
	TurnOff();
	if(GetConVarBool(hAutoUpdate)&&LibraryExists("pluginautoupdate")) { 
		AutoUpdate_RemovePlugin(); 
	}
}

public OnMapStart()
{
	PrecacheModel(TSPRITE);
	PrecacheModel(CTSPRITE);
}
public OnClientPutInServer(client)
{
	espon[client]=false;
	transmit[client]=false;
}
public OnAllPluginsLoaded() { 
	if(GetConVarBool(hAutoUpdate)&&LibraryExists("pluginautoupdate")) { 
		AutoUpdate_AddPlugin("kawman.tk", "/SourceMOD/adminesp.xml", PLUGIN_VERSION);
	} 
	
	configs_on = GetConVarBool(cConfigs);
}
public OnClientDisconnect(client) {
	espon[client] = false;
	cheaton[client] = false;
	transmit[client] = false;
	CreateTimer(0.2, DelayedCheck, client);
}
public MyCVARChange(Handle:convar, const String:oldValue[], const String:newValue[])
{
	if(convar==hAutoUpdate&&LibraryExists("pluginautoupdate")&&LibraryExists("pluginautoupdate")) {
		if(StringToInt(oldValue)==0&&StringToInt(newValue)==1) {
			AutoUpdate_AddPlugin("kawman.tk", "/SourceMOD/adminesp.xml", PLUGIN_VERSION);
		} else if(StringToInt(oldValue)==1&&StringToInt(newValue)==0) {
			AutoUpdate_RemovePlugin(); 
		}
	} 
	else if(convar == cConfigs) {
		if(StringToInt(newValue) == 1) {
			configs_on = true;
		} else {
			configs_on = false;
		}
	}
	else if(convar == cSvCheats) {
		SvCheats = GetConVarBool(cSvCheats);
	}
	
}

UpdateState() {
	configs_on = GetConVarBool(cConfigs);
	SvCheats = GetConVarBool(cSvCheats);
}
bool:CreateSprite(client)
{
	#if DEBUG>1
	new String:obsname[64];
	if(observing[client]<=0||observing[client]>MaxClients) obsname = "non";
	else GetClientName(observing[client], obsname, sizeof(obsname));
	PrintToServer("[AdminESP][DEBUG] Creating sprite for %d %s", client,obsname);
	#endif
	new String:model[64];
	if(!ValidPlayer(client)) return false;
	new clientteam = GetClientTeam(client);
	if(clientteam==T_TEAM)
	{
		model=TSPRITE;
	}
	else if(clientteam==CT_TEAM)
	{
		model=CTSPRITE;
		new String:curmodel[256];
		GetClientModel(client, curmodel, sizeof(curmodel));
		if(StrEqual(curmodel,BUGEDMODEL1,false)||StrEqual(curmodel,BUGEDMODEL2,false))
		{
			SetEntityModel(client, "models/player/ct_urban.mdl");
		}
	}
	else
	{
		return false;
	}
	if(clientsprite[client]!=-1)	{
		DestroyEnt(clientsprite[client]);
		clientsprite[client]=-1;
	}

	clientsprite[client] = CreateEntityByName("env_sprite"); 
	if(clientsprite[client]!=-1) 
	{
		#if DEBUG > 0
		new String:obsname[64];
		if(observing[client]>=1||observing[client]<=MaxClients) {
			GetClientName(client, obsname, sizeof(obsname));
			PrintToServer("[AdminESP][DEBUG]Creating spirit for: %d %s",client,obsname);
		}
		#endif
		decl String:buffer[256], Float:vecOrigin[3]; 
		Format(buffer, sizeof(buffer), "espclient%d", client); 
		DispatchKeyValue(client, "targetname", buffer); 
		DispatchKeyValue(clientsprite[client], "model", model); 
		DispatchKeyValue(clientsprite[client], "rendermode", "0"); 
		DispatchKeyValue(clientsprite[client], "renderfx", "0"); 
		DispatchKeyValue(clientsprite[client], "renderamt", "255"); 
		DispatchKeyValue(clientsprite[client], "scale", "0.5"); 
		DispatchKeyValue(clientsprite[client], "GlowProxySize", "61.0");
		#if DEBUG > 0
		GetClientName(client, obsname, sizeof(obsname));
		new bool:tmp = DispatchSpawn(clientsprite[client]);
		if(!tmp) {
			PrintToServer("[AdminESP][DEBUG] Can't spawn %d for %d %s", clientsprite[client], client, obsname);
		} else {
			PrintToServer("[AdminESP][DEBUG] Spawned %d for %d %s",clientsprite[client],client,obsname);
		}
		#else
		DispatchSpawn(clientsprite[client]);
		#endif
		//GetClientEyePosition(client, vecOrigin);
		GetClientAbsOrigin(client, vecOrigin);
		vecOrigin[2] -= 5.0; 
		TeleportEntity(clientsprite[client], vecOrigin, NULL_VECTOR, NULL_VECTOR); 

		SetVariantString(buffer); 
		#if DEBUG > 0
		tmp = AcceptEntityInput(clientsprite[client], "SetParent"); 
		if(!tmp) {
			PrintToServer("[AdminESP][DEBUG] Accept SetPatern Faild %d, %d, %s", clientsprite[client], client, obsname);
		}
		#else
		AcceptEntityInput(clientsprite[client], "SetParent"); 
		#endif
		SetVariantString("forward");
		#if DEBUG > 0
		tmp = AcceptEntityInput(clientsprite[client], "SetParentAttachmentMaintainOffset");
		if(!tmp) {
			PrintToServer("[AdminESP][DEBUG] Accept SetPatern Faild %d, %d, %s", clientsprite[client], client, obsname);
		}
		#else
		AcceptEntityInput(clientsprite[client], "SetParentAttachmentMaintainOffset");
		#endif
		SDKHook(clientsprite[client], SDKHook_SetTransmit, Hook_SetTransmit);
	} 
	#if DEBUG > 0
	else {
		PrintToServer("[AdminESP][DEBUG] Filed to create env_sprite");
	}
	#endif
	return true;
}

public Action:CmdAdminESP(client, args)
{
	if(!client) {
		ReplyToCommand(client, "[AdminESP] In-Game Only");
		return Plugin_Handled;
	}
	if (args > 2)
	{
		ReplyToCommand(client, "[AdminESP] Usage: sm_adminesp [0-off,1-on] [#userid|name|team|all]");
		return Plugin_Handled;
	}
	if (args == 0)
	{
		//self toggle
		if(espon[client]) {
			espon[client] = false;
		}else {
			espon[client]=true;
		}
		RefreshClientTran(client);
	}
	else if (args == 1)
	{
		//self set
		decl String:arg[65];
		GetCmdArg(1, arg, sizeof(arg));
		new mystate = StringToInt(arg);
		if(mystate) 
		{
			espon[client] = true; 
		}
		else 
		{
			espon[client]=false;
		}
		RefreshClientTran(client);
	}
	else 
	{
		decl String:arg[65];
		GetCmdArg(2, arg, sizeof(arg));

		decl String:target_name[MAX_TARGET_LENGTH];
		decl target_list[MAXPLAYERS], target_count, bool:tn_is_ml;
		
		if ((target_count = ProcessTargetString(
				arg,
				client,
				target_list,
				MAXPLAYERS,
				COMMAND_FILTER_CONNECTED,
				target_name,
				sizeof(target_name),
				tn_is_ml)) <= 0)
		{
			ReplyToTargetError(client, target_count);
			return Plugin_Handled;
		}
		
		GetCmdArg(1, arg, sizeof(arg));
		new mystate = StringToInt(arg);
		
		for (new i = 0; i < target_count; i++)
		{
			if(mystate) 
			{
				espon[target_list[i]] = true;
			}
			else 
			{
				espon[target_list[i]]= false;
			}
			RefreshClientTran(target_list[i]);
		}
	}
	
	if((sbeon = ShouldBeOn()))
	{
		TurnOnFromZero();
	}
	else
	{
		TurnOff();
	}
	return Plugin_Handled;
}

public Action:CmdAdminCheat(client, args)
{
	if(!client) {
		ReplyToCommand(client, "[AdminESP] In-Game Only");
		return Plugin_Handled;
	}
	if (args > 2)
	{
		ReplyToCommand(client, "[AdminESP] Usage: sm_admincheat [0-off,1-on] [#userid|name|team|all]");
		return Plugin_Handled;	
	}
	if (args == 0)
	{
		//self toggle
		if(cheaton[client]) {
			PrintToChat(client, "[AdminESP] Cheats for Admins DISABLED");
			cheaton[client] = false;
		}else {
			PrintToChat(client, "[AdminESP] Cheats for Admins ENABLED");
			cheaton[client]=true;
		}
		RefreshClientTran(client);
	}
	else if (args == 1)
	{
		//self set
		decl String:arg[65];
		GetCmdArg(1, arg, sizeof(arg));
		new mystate = StringToInt(arg);
		if(mystate) 
		{
			PrintToChat(client, "[AdminESP] Cheats for Admins ENABLED");
			cheaton[client] = true; 
		}
		else 
		{
			PrintToChat(client, "[AdminESP] Cheats for Admins DISABLED");
			cheaton[client]=false;
		}
		RefreshClientTran(client);
	}
	else 
	{
		decl String:arg[65];
		GetCmdArg(2, arg, sizeof(arg));

		decl String:target_name[MAX_TARGET_LENGTH];
		decl target_list[MAXPLAYERS], target_count, bool:tn_is_ml;
		
		if ((target_count = ProcessTargetString(
				arg,
				client,
				target_list,
				MAXPLAYERS,
				COMMAND_FILTER_CONNECTED,
				target_name,
				sizeof(target_name),
				tn_is_ml)) <= 0)
		{
			ReplyToTargetError(client, target_count);
			return Plugin_Handled;
		}
		
		GetCmdArg(1, arg, sizeof(arg));
		new mystate = StringToInt(arg);
		
		for (new i = 0; i < target_count; i++)
		{
			if(mystate) 
			{
				PrintToChat(client, "[AdminESP] Cheats for Admins enabled");
				cheaton[target_list[i]] = true;
			}
			else 
			{
				PrintToChat(client, "[AdminESP] Cheats for Admins disabled");
				cheaton[target_list[i]]= false;
			}
			RefreshClientTran(target_list[i]);
		}
	}
	
	return Plugin_Handled;
}

public Action:CmdAdminESPTable(client, args)
{
	ReplyToCommand(client, "------------ ADMINESP Cur Config Table ----------------");
	ReplyToCommand(client, "ShouldBeON: %d", sbeon);
	for(new i=0;i<=MaxClients;i++)
	{
		ReplyToCommand(client, "Client:%d espon:%d transmit:%d observing:%d, clientsprite:%d, cheatson:%d",
		i, espon[i], transmit[i], observing[i], clientsprite[i], cheaton[i]
		);
	}
	ReplyToCommand(client, "------------ END ADMINESP Cur Config Table ----------------");
	return Plugin_Handled;
}

/* -------------------- EVENTS	-----------------------------*/
public Action:Event_PlayerSpawn(Handle:event, const String:name[], bool:dontBroadcast)
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	RefreshClientTran(client);

	if(sbeon)
	{
		CreateTimer(1.0, DelayedCreate, client);
	}

}
public Action:Event_RoundStart(Handle:event, const String:name[], bool:dontBroadcast)
{
	sbeon = ShouldBeOn();
	RefreshTransmit();
}

public Action:Event_PlayerDeath(Handle:event, const String:name[], bool:dontBroadcast)
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	RefreshClientTran(client);
	DestroyEnt(clientsprite[client]);
	clientsprite[client]=-1;
}

/* -------------------- HOOKS	-----------------------------*/
public Action:Hook_SetTransmit(entity, client) 
{
	if(transmit[client])
	{
		if(entity!=clientsprite[observing[client]])
		{
			return Plugin_Continue;
		}
	}
	return Plugin_Handled; 
}

/* -------------------- TIMERS CB  -----------------------------*/

public Action:DelayedCreate(Handle:timer, any:client)
{
	CreateSprite(client);
}

public Action:DelayedCheck(Handle:timer, any:client)
{
	if((sbeon = ShouldBeOn()))
	{
		TurnOnFromZero();
	}
	else
	{
		TurnOff();
	}
}

public Action:Timer_ObserverRefresh(Handle:timer, any:client)
{
	if(!IsClientInGame(client)) return Plugin_Stop;
	if(!transmit[client]) return Plugin_Stop;
	if(ObserverRefresh[client]!=timer) return Plugin_Stop;
	
	if(IsPlayerAlive(client))
	{
		observing[client] = client;
	}
	else
	{
		observing[client]=GetEntDataEnt2(client, g_offObserverTarget);
		if(observing[client]<1|| observing[client]>MaxClients)
		{
			observing[client] = client;
		}
	}
	#if DEBUG>2
	new String:obsname[64];
	if(observing[client]<=0||observing[client]>MaxClients) obsname = "non";
	else GetClientName(observing[client], obsname, sizeof(obsname));
	PrintToServer("[AdminESP][DEBUG] Client %d observing %d %s", client, observing[client], obsname);
	#endif
	return Plugin_Continue;
}

/* -------------------- HELP FUNCTIONS --------------------------*/

RefreshTransmit()
{
	for(new i=1;i<=MaxClients;i++)
	{
		RefreshClientTran(i);
	}
	#if DEBUG>0
	PrintToServer("[AdminESP][DEBUG] Transmit for all Refreshed");
	#endif
}

RefreshClientTran(client)
{
	if(!IsClientInGame(client)) {
		espon[client] = false;
		cheaton[client] = false;
		return;
	}
	if(espon[client])
	{
		if(ValidObserver(client))
		{
			transmit[client] = true;
			ObserverRefresh[client] = CreateTimer(5.0, Timer_ObserverRefresh, client, TIMER_REPEAT);
		}
		else
		{
			transmit[client] = false;
		}
	}
	else
	{
		transmit[client] = false;
	}
	if(!SvCheats&&!IsFakeClient(client)) {
		if(cheaton[client]&&!IsPlayerAlive(client)) {
			if(configs_on && !configs_on_executed) {
				configs_on_executed = true;
				ServerCommand("exec sourcemod/admincheats_on.cfg");
			}
			SendConVarValue(client, cSvCheats, "1");
		} else {
			if(configs_on && configs_on_executed) {
				//Check if someone is still using, if not execute re-enable config
				new bool:still_watching = false;
				for(new i=1;i<=MaxClients;i++) {
					if(IsClientInGame(i)&&!IsPlayerAlive(i)&&cheaton[i]) {
						still_watching = true;
					}
				}
				if(!still_watching) {
					configs_on_executed = false;
					ServerCommand("exec sourcemod/admincheats_off.cfg");
				}
			}
			SendConVarValue(client, cSvCheats, "0");
		}
	}
	
	#if DEBUG>1
	PrintToServer("[AdminESP][DEBUG] Transmit for %d Refreshed",client);
	#endif
}

DestroyEnt(ent)
{
	if(IsValidEntity(ent))
	{
	
		RemoveEdict(ent);
		SDKUnhook(ent, SDKHook_SetTransmit, Hook_SetTransmit);
	}
	#if DEBUG>2
	PrintToServer("[AdminESP:DEBUG] DestroyEnt(%d) Valid:%d",ent, IsValidEntity(ent));
	#endif
}

ValidPlayer(client)
{
	if(!IsClientConnected(client)) return false;
	if(!IsClientInGame(client)) return false;
	if(!IsPlayerAlive(client)) return false;
	return true;
}

ValidObserver(client)
{
	if(!IsClientConnected(client)) return false;
	if(!IsClientInGame(client)) return false;
	if(IsPlayerAlive(client)) return false;
	return true;
}

TurnOff()
{
	#if DEBUG>1
	PrintToServer("[AdminESP:DEBUG] Turn Off Start");
	#endif
	for(new i=1;i<=MaxClients;i++)
	{
		SDKUnhook(clientsprite[i], SDKHook_SetTransmit, Hook_SetTransmit);
		DestroyEnt(clientsprite[i]);
		clientsprite[i] = -1;
		espon[i] = false;
		transmit[i] = false;
		observing[i] = 0;
	}
	#if DEBUG>0
	PrintToServer("[AdminESP:DEBUG] Turned Off");
	#endif
}

TurnOnFromZero()
{
	#if DEBUG>1
	PrintToServer("[AdminESP][DEBUG] TurnOnFromZero Start");
	#endif
	for(new i=1;i<=MaxClients;i++)
	{
		CreateSprite(i);
	}
	#if DEBUG>0
	PrintToServer("[AdminESP][DEBUG] Turned On from zero");
	#endif
}

bool:ShouldBeOn() //what: 0=check for adminesp on 1=check for admincheat
{
	#if DEBUG>0
	PrintToServer("[AdminESP:DEBUG] ShouldBeOn() Checking state ");
	#endif
	for(new i=1;i<=MaxClients;i++)
	{
		if(espon[i])
		{
			return true;
		}
	}
	return false;
}